# configurator - simple config program for midori linux
# written by Claudio Fleiner
#
# Copyright (C) 2000 Transmeta Corporation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

use strict;
use Carp;

require "MENU.pm";
require "PRG.pm";
require "PARAMETER.pm";
require "ML.pm";
require "CONFIG.pm";

# Wrapper for all other packages, contains some global variables
# and a function to reread all user config files and the ones
# stored in each package (CONFIG)
package MAIN;

use vars qw ( $config $conf $build $user_config );

$config=$ENV{'CONFIG'};
$conf="$ENV{'CACHE'}/config";
$build="$ENV{'BUILD'}";
$user_config="";

# Reload user config file and all CONFIG files
sub reload {
   MENU::clear();
   ML::clear();
   $MAIN::user_config=CONFIG::read_file($MAIN::config);
   my $edited=0;
   my $top=MENU::get("","Midori Linux Configuration");
   my $apps=$ENV{'APPS'};
   $apps=$MAIN::user_config->{'APPS'} if(exists($MAIN::user_config->{'APPS'}));

   foreach my $i (split(/ +/,"$ENV{'BASE'} $apps")) {
      foreach my $j (glob("$i/*.ml[zb]")) {
         my $ml=ML::new($j);
      }
   }
}

1;
