##########################################################################
# configurator - simple config program for midori linux
# written by Claudio Fleiner
#
# Copyright (C) 2000 Transmeta Corporation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package MENU;

# print all the changes that would happen if all packages would be disabled
sub print_disable() {
   my $self=shift;
   my $file=shift;
   my $c=$self->children;
   foreach my $i (@$c) { $i->print_disable($file); }
}

# print all the changes that would happen if all packages would be enabled
sub print_enable() {
   my $self=shift;
   my $file=shift;
   my $c=$self->children;
   foreach my $i (@$c) { $i->print_enable($file); }
}

# Print all changes that have been done since the last save
sub print_changes() {
   my $self=shift;
   my $file=shift;
   my $c=$self->children;
   my $i;
   foreach $i (@$c) {
      $i->print_changes($file);
   }
}

# print all the changes that would happen if all option would be set to 
# their default value
sub print_whatif_default() {
   my $self=shift;
   my $file=shift;
   my $conf=shift;
   my $c=$self->children;
   foreach my $i (@$c) { $i->print_whatif_default($file); }
}

# print all the changes that would happen if all option would be set to 
# a value defined in a config file selected by "import"
sub print_whatif() {
   my $self=shift;
   my $file=shift;
   my $conf=shift;
   my $c=$self->children;
   foreach my $i (@$c) { $i->print_whatif($file,$conf); }
}


# Print the menu bar
sub print_menu() {
   my $self=shift;
   my $file=shift;
   my $level=shift;

   if($level) {
      print $file "<dt>";
      print $file "<img src=magenta.gif width=13 height=16 alt=\"*\">&nbsp;";
      print $file "<b>" if($level<2);
      my $tmp=$self->title;
      $tmp =~ s/ /&nbsp;/g;
      print $file "$tmp";
      print $file "</b>" if($level<2);
      print $file "<DD><DL>\n";
      my $ref=$self->children;
      foreach my $i (@$ref) { $i->print_menu($file,$level+1); }
      print $file "</DL>\n";
   } else {
      my $ref=$self->children;
      foreach my $i (@$ref) { $i->print_menu($file,$level+1); }
   }
}

1;
