##########################################################################
# configurator - simple config program for midor linux
# written by Claudio Fleiner
#
# Copyright (C) 2000 Transmeta Corporation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

package PRG;


# Print the title, and package selection form elements for the
# standard webconfig form. Uses the subpackage to print the paramters.
sub print_html() {
   my $self=shift;
   my $file=shift;

   my $i;
   my $ev=$self->edit;
   my $ref=$self->children;
   my $x=$$ref[0];
   print $file "<html><head></head><body bgcolor=#ffffff text=#000000 link=#0000ee vlink=#0000ee alink=#0000ee>";
   print $file "<form target=config action=/config.cgi method=GET>\n";

   print $file "<table border=0><tr><th valign=top align=left valign=center ";
   if($ev eq "no") {
      print $file "bgcolor=ff0000";
   } else { 
      print $file "bgcolor=00ff00";
   }
   my $prm;
   print $file " width=10><input type=checkbox name=select ".($ev ne "no"?"checked":"").">&nbsp;";
   print $file "<a name=\"".$self->menu."\"></a><a href=/packhelp.cgi?ml=".SERVER::eurl($ev eq "no"?$x->val:$ev)." target=help>".($self->name)."</a></th>\n";
   if(@$ref == 1 ) {
      $prm=$x->params;
      print $file "<th align=left colspan=2>&nbsp;".($x->val)."</th></tr>\n";
      print $file "<tr><td colspan=3>".$x->title."\n";
      print $file "<input type=hidden name=prg value=\"".$x->val."\"></td></tr>\n";
      $x->print_param($file);
   } elsif(@$ref > 1) {
      my $pp=$$ref[0];
      print $file "<th align=left colspan=2><select name=prg>\n";
      foreach $i (@$ref) {
         print $file "<option value=".$i->val;
         if($i->val eq $ev) {
            print $file " selected";
            $pp=$i;
         }
         print $file ">".$i->val."</option>\n";
      }
      print $file "</select> <input type=submit name=action value=Update></th></tr>\n";
      print $file "<tr><td colspan=3>".$pp->title."</td></tr>\n";
      $pp->print_param($file);
      $prm=$pp->params;
   } else {
   }
   if(@$prm>0) {
      print $file "</td></tr><tr><td colspan=4 align=left><input type=submit name=action value=\"Accept\"> <input type=submit name=action value=\"Default Values\"> <input type=submit name=action value=\"Config File Values\"> <input type=reset value=\"Reset Fields\"></td></tr></table></form></body></html>\n";
   } else {
      print $file "</td></tr><tr><td colspan=4 align=center><input type=submit name=action value=\"Accept\"></td></tr></table></form></body></html>\n";
   }
}

# Print all the changes that happenend to the main selection
# of the package, uses subpackage to print changes to parameters.
sub print_changes() {
   my $self=shift;
   my $file=shift;
   my $conf=$MAIN::user_config->{$self->var};
   my $ch=$self->children;
   

   my $title="<h3><img src=".($self->edit eq"no"?"red":"green").".gif width=13 height=16>&nbsp;<a target=config href=/configedit.cgi?prg=".SERVER::eurl($self->menu).">".$self->name."</a></h3>\n";
   $conf="" if(!defined($conf));

   if(@$ch>1 || $conf eq "no" || $self->edit eq "no") {
      if($self->edit ne $conf) {
         print $file $title;
         if($self->edit eq "no") {
            print $file "This package has now been disabled.<br>\n";
         } elsif($conf eq "no") {
            print $file "This package (version ".$self->edit.") will be installed, was disabled so far.<br>\n";
         } else {
            print $file "Version changed: new version ".$self->edit.", old version: ".($conf eq ""?"undefined":$conf)."<br>\n";
         }
         $title="";
      }
   }
   
   if($self->edit ne "no") {
      my $prg=$self->child($self->edit);
      $prg->print_changes($file,$title);
   }
}

# Print all the changes that will happen if a config file is
# imported (parameter changes are dealt with in the subpackage).
sub print_whatif() {
   my $self=shift;
   my $file=shift;
   my $conf=shift;
   my $ch=$self->children;
   

   my $title="<h3><a target=config href=/configedit.cgi?prg=".SERVER::eurl($self->menu).">".$self->name."</a></h3>\n";
   $conf="" if(!defined($conf));

   my $src=$conf->{$self->var};
   if(defined($src) && (($src eq "no" && $self->edit ne "no") || ($src ne "no" && $self->edit eq "no") ||
                         ($src ne "yes" && $src ne "no" && $self->edit ne $src))) {
      print $file $title;
      if($src eq "no" ) {
         print $file "This package will be disabled.<br>\n";
      } elsif($src eq "yes") {
         print $file "This package will be enabled (using version ".$self->first.").<br>\n";
      } else {
         print $file "Instead of the previous version package version $src will be installed<br>\n";
         if(!defined($self->find($src))) {
            print $file "<font color=red><big>WARNING: this version of the package can not be found, after importing this file you will have inconsistent configuration data!</big></font><br>\n";
         }
      }
   }
   
   if(!defined($src) || $src ne "no") {
      my $ml;
      if($self->edit eq "no") {
         $ml=$self->child($self->first);
      } else {
         $ml=$self->child($self->edit);
      }
      $ml->print_whatif($file,$title,$conf) if(defined($ml));
   }
}

# Print all the changes that will happen if this package will be disabled.
sub print_disable() {
   my $self=shift;
   my $file=shift;
   if($self->edit ne "no") {
      print $file "<img src=red.gif width=13 height=16 alt=\"-\">".$self->name."<br>\n";
   }
}

# Print all the changes that will happen if this package will be enabled.
sub print_enable() {
   my $self=shift;
   my $file=shift;
   if($self->edit eq "no") {
      print $file "<img src=green.gif width=13 height=16 alt=\"-\">".$self->name."<br>\n";
   }
}

# Print all the changes that will happen if the default values are used
# (parameter changes are dealt with in the subpackage).
sub print_whatif_default() {
   my $self=shift;
   my $file=shift;
   my $ch=$self->children;
   

   my $title="<h3><a target=config href=/configedit.cgi?prg=".SERVER::eurl($self->menu).">".$self->name."</a></h3>\n";
   $conf="" if(!defined($conf));

   my $src=$conf->{$self->var};
   if($self->edit ne $self->first) {
      print $file $title;
      print $file "This package will be enabled (using version ".$self->first.").<br>\n";
      if($self->edit eq "no") {
         print $file "Currently it is disabled<p>\n";
      } else {
         print $file "Currently it would install verion ".$self->edit."<p>\n";
      }
      $title="";
   }
   
   my $ml=$self->child($self->first);
   $ml->print_whatif_default($file,$title) if(defined($ml));
}


# Print the menu entry for this package
sub print_menu() {
   my $self=shift;
   my $file=shift;
   my $level=shift;

   my $e=$self->edit;
   my $c=$self->children;
   print $file "<dt>";
   if($e eq "no") {
      print $file "<a href=\"/config.cgi?prg=".SERVER::eurl($$c[0]->val)."&select=on\" target=config><img border=0 src=red.gif width=13 height=16 alt=\"-\"></a>&nbsp;";
   } else { 
      print $file "<a href=\"/config.cgi?prg=".SERVER::eurl($$c[0]->val)."\" target=config><img border=0 src=green.gif width=13 height=16 alt=\"+\"></a>&nbsp;";
   }
   my $tmp=$self->title;
   $tmp =~ s/ /&nbsp;/g;
   my $hasparam=0;
   my $ml;
   if($e eq "no") {
      $ml=$$c[0];
   } else {
      $ml=$self->child($e);
      $ml=$$c[0] if(!defined($ml) || $ml==0);
   }
   my $p=$ml->params;
   $hasparam=(@$p);
   my $changed=((@$c)>1) || $ml->changed;
   my $edited=$ml->edited;
   $edited=1 if($self->edit ne $self->config);
   my $error=$ml->has_error;

   print $file "<img src=/dead.gif width=16 height=16 alt=\"[ERROR] \">&nbsp;" if($error);
   print $file "<a name=".$self->menu."></a><a target=package href=\"package.cgi?name=".SERVER::eurl($self->menu)."\">$tmp</a>";

   print $file "&nbsp;[*]" if($changed);
   print $file "&nbsp;[+]" if($edited);
   print $file "&nbsp;..." if($hasparam>0);
   print $file "<dd>\n";
   $MAIN::edited=1 if($edited); 
}

1;
