##########################################################################
# configurator - simple config program for midor linux
# written by Claudio Fleiner
#
# Copyright (C) 2000 Transmeta Corporation
#
# This program is free software; you can redistribute it and/or modify
# it under the terms of the GNU General Public License as published by
# the Free Software Foundation; either version 2 of the License, or
# (at your option) any later version.
#
# This program is distributed in the hope that it will be useful,
# but WITHOUT ANY WARRANTY; without even the implied warranty of
# MERCHANTABILITY or FITNESS FOR A PARTICULAR PURPOSE.  See the
# GNU General Public License for more details.
#
# You should have received a copy of the GNU General Public License
# along with this program; if not, write to the Free Software
# Foundation, Inc., 59 Temple Place, Suite 330, Boston, MA  02111-1307  USA

require "HTTPD_MENU.pm";
require "HTTPD_PARAMETER.pm";
require "HTTPD_PRG.pm";
require "HTTPD_ML.pm";

package SERVER;

use Carp;
use Carp qw(cluck);
use Socket;

my $body="<body bgcolor=#ffffff text=#000000 link=#0000ee vlink=#0000ee alink=#0000ee>";

# some build in html docs.
my %htmlrequest =  (
      "/index.html",
            "<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
            <frameset border=0 rows=50,* frameborder=0 noresize framespacing=0>
                 <frame src=sky.html scrolling=no marginwidth=0>
                 <frame name=config src=config.html scrolling=no marginwidth=1>
            </frameset>\n",

      "/config.html",
            "<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
            <frameset border=1 cols=$ENV{CONFIGURATOR_MENU_WIDTH},* frameborder=1 framespacing=0 >
               <frame name=menu src=menu.cgi scrolling=yes>
               <frameset border=0 rows=*,$ENV{CONFIGURATOR_CONTROL_HEIGHT} noresize frameborder=0 framespacing=0 >
                    <frame name=package src=package.html scrolling=no>
                    <frame name=control src=control.cgi scrolling=no>
               </frameset>    
            </frameset>\n",

      "/package.html",
            "<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
               <frameset border=1 rows=*,$ENV{CONFIGURATOR_HELP_HEIGHT} frameborder=1 framespacing=0 >
                    <frame name=main src=welcome.html scrolling=yes>
                    <frame name=help src=help.html scrolling=yes>
               </frameset>\n",



      "/sky.html",
            "<html>$body
            <TABLE BORDER =\"0\" WIDTH =\"100%\" CELLPADDING =\"0\" CELLSPACING =\"0\">
               <TR>
                     <TD BACKGROUND=\"/lsky.jpg\" WIDTH=\"33%\">&nbsp;</TD>
                     <TD WIDTH='33%'><a href=config.html target=config><IMG SRC=\"/sky.jpg\" ALT=\"[The Midori Configuration Utility]\" WIDTH=\"600\" HEIGHT=\"103\" border=0></a></TD>
                     <TD BACKGROUND=\"/rsky.jpg\" WIDTH=\"34%\">&nbsp;</TD>
               </TR>
            </TABLE>
            </body></html>",

      "/help.html",
            "<html>$body<h1>HELP</h1>This screen is used to display various explanations and helpful information.</html>\n",
      
      "/welcome.html",
         "<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Wecome to the Midori Linux Configuration</title></head>
         <body bgcolor=ffffff><p>&nbsp;<p>&nbsp;<p><center>
         <h1 align=center>Welcome to the Midori Linux Configuration Utility</h1>
         <p align=center><img src=midori.gif></center></body></html>",

);


# print standard HTTP header/title
sub print_title {
   my $self=shift;
   $self->print_html("HTTP/1.0 200 OK\r\nContent-Type: text/html\r\nConnection: close\r\n\r\n");
}

# Return an error message
sub http_error {
   my $self=shift;
   my $number=shift;
   my $message=shift;
   $self->print_html("HTTP/1.0 $number $message\r\nContent-Type: text/html\r\nConnection: close\r\n\r\n");
   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>ERROR: $number $message</title></head><body bgcolor=ff3333><h1>ERROR: $err $message</h1></body></html>\n");
}

# Send a file (first the build files are checked, see above)
sub send_file {
   my $self=shift;
   my $img=shift;
   my $f;

   $c=$htmlrequest{$img};
   if((defined $c) and ($c ne "")) {
      $self->print_title;
      $self->print_html($c);
      return 1;
   }

   $f=$ENV{HTDOCS}.$img if(-f $ENV{HTDOCS}.$img);
   $f=$ENV{TOPDIR}."/docs".$img if(!defined($f) && -f $ENV{TOPDIR}."/docs".$img);

   my $x=open(IMG,$f);
   if(!$x) {
      $self->http_error(404,"File not found");
   } else {
      my $type="text/ascii";
      $type="image/jpeg" if($img =~ /\.jpe?g$/i);
      $type="image/gif" if($img =~ /\.gif$/i);
      $type="image/x-icon" if($img =~ /\.ico$/i);
      $type="text/html" if($img =~ /\.html$/i);
      $type="text/plain" if($img =~ /\.txt$/i);
      $self->print_html("HTTP/1.0 200 OK\r\nContent-Type: $type\r\nConnection: close\r\n\r\n");
      while(<IMG>) { $self->print_html($_); } 
      close IMG;
   }
}

# convert URL to http form (spaces, pluses and ampersands are converted)
sub eurl {
   my $s=shift;
   $s=~s/%/%25/g;
   $s=~s/\+/%2B/g;
   $s=~s/\&/%26/g;
   $s=~s/\?/%3F/g;
   $s=~s/ /+/g;
   return $s;
}

# send agruments to the browser
sub print_html {
   my $self=shift;
   my $s=$self->csocket;
   print $s @_;
}

# set or return the socket used to communicate with the browser
sub csocket {
   my $self=shift;
   $self->{SOCKET}=shift if(@_);
   return $self->{SOCKET};
}

# Currently requested URL 
sub url {
   my $self=shift;
   $self->{URL}=shift if(@_);
   return $self->{URL};
}

# Clear all fields that were defined in previously worked on forms
sub clear_fields {
   my $self=shift;
   $self->{FIELDS}={ };
}

# Set or return a field value
# $1: self
# $2: field name
# $3: field value (optional)
sub field {
   my $self=shift;
   my $field=shift;
   my $f=$self->{FIELDS};
   if(@_) {
      $$f{$field}.=" " if(defined($$f{$field}));
      $$f{$field}.=shift;
   }
   return $$f{$field};
}

# returns true if a field exists in the form currently in work
sub field_exists {
   my $self=shift;
   my $field=shift;
   my $f=$self->{FIELDS};
   return exists $$f{$field};
}

# print the left menu bar 
sub menu {
   my $self=shift;
   my $top=MENU::get("");
   $self->print_title();

   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Menu</title></head>$body\n");
   $self->print_html("<h1>Table&nbsp;of&nbsp;Contents</h1>\n");
   $self->print_html("<dl>\n");
   $self->print_html("<dt><img src=magenta.gif width=13 height=16 alt=\"*\">&nbsp;<b>Help</b><dd><DL>");
   $self->print_html("<dt><img src=blue.gif width=13 height=16 alt=\"*\">&nbsp;<a href=/help.cgi?help=menuhelp.html target=package>The&nbsp;Menu</a><dd>");
   $self->print_html("<dt><img src=blue.gif width=13 height=16 alt=\"*\">&nbsp;<a href=/help.cgi?help=mainhelp.html target=package>The&nbsp;Parameters</a><dd>");
   $self->print_html("<dt><img src=blue.gif width=13 height=16 alt=\"*\">&nbsp;<a href=/help.cgi?help=confighelp.html target=package>The&nbsp;Configuration&nbsp;File</a><dd>");
   $self->print_html("<dt><img src=blue.gif width=13 height=16 alt=\"*\">&nbsp;<a href=/manual/index.html target=config>The&nbsp;Midori&nbsp;Manual</a><dd>");
   $self->print_html("<dt><img src=blue.gif width=13 height=16 alt=\"*\">&nbsp;<a href=/packages/frame.html target=config>The&nbsp;Midori&nbsp;Package&nbsp;Documentation</a><dd>") if(-f $ENV{TOPDIR}."/docs/packages/frame.html");
   $self->print_html("</dl>\n");

   MENU::top->print_menu($self->csocket,0); 
}

# Print the package configuration frame
sub package {
   my $self=shift;
   my $name=$self->field("name");
   my $prg=PRG::get($name);
   my $ref=$prg->children;
   my $ml=$$ref[0];
   my $help=$prg->edit;
   my $ev=$ml->val;
   $help=$ev if($help eq "no");
   $self->print_title();
   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
               <frameset border=1 rows=*,$ENV{CONFIGURATOR_HELP_HEIGHT} frameborder=1 framespacing=0 >
                    <frame name=main src=packparm.cgi?name=".SERVER::eurl($name)." scrolling=yes>
                    <frame name=help src=packhelp.cgi?ml=".SERVER::eurl($help)." scrolling=yes>
               </frameset>\n");
}

# Print the package configuration form
sub packparm {
   my $self=shift;
   my $prg=PRG::get($self->field("name"));
   $self->print_title();
   $prg->print_html($self->csocket);
}

# Print the package help screen
sub packhelp {
   my $self=shift;
   my $ml=ML::get($self->field("ml"));
   $self->print_title();
   $ml->printhelp($self->csocket);
}

# Manages the result of the package form
# - setting of values
# - switching to default values
# - changing package version
sub config {
   my $self=shift;
   my $prgname=$self->field("prg");
   my $ml=ML::get($prgname);
   my $select=$self->field("select");
   my $params=$ml->params;
   my $prg=$ml->parent;
   my $c=$prg->children;
   foreach my $i (@$params) {
      $i->fixfields($self->{FIELDS});
   }

   $select="" if(!defined($select));

   if("$select" eq "") {
      $prg->edit("no");
   } else {
      $prg->edit($ml->val);
   }

   my $action=$self->field("action");
   $action="" if(!defined($action));
   my $i;
   if($action eq "Accept") {
      foreach $i (@$params) {
         $i->edit($self->field($i->name)) if($self->field_exists($i->name));
      }
   } elsif($action eq "Default Values") {
      foreach $i (@$params) {
         $i->edit($i->default);
      }
   } elsif($action eq "Config File Values") {
      foreach $i (@$params) {
         $i->edit($i->config);
      }
   }
   
   $self->print_title();
   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
            <frameset border=1 cols=$ENV{CONFIGURATOR_MENU_WIDTH},* frameborder=1 framespacing=0 >
               <frame name=menu src=menu.cgi#".$prg->menu." scrolling=yes>
               <frameset border=0 rows=*,$ENV{CONFIGURATOR_CONTROL_HEIGHT} noresize frameborder=0 framespacing=0 >
                    <frame name=package src=/package.cgi?name=".SERVER::eurl($prg->menu)." scrolling=no>
                    <frame name=control src=control.cgi scrolling=no marginwidth=1>
               </frameset>    
            </frameset>\n");
}

# configedit is used by the menu bar
sub configedit {
   my $self=shift;
   my $prg=PRG::get($self->field("prg"));
   $self->print_title();
   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head>
            <frameset border=1 cols=$ENV{CONFIGURATOR_MENU_WIDTH},* frameborder=1 framespacing=0 >
               <frame name=menu src=menu.cgi#".$prg->menu." scrolling=yes>
               <frameset border=0 rows=*,$ENV{CONFIGURATOR_CONTROL_HEIGHT} noresize frameborder=0 framespacing=0 >
                    <frame name=package src=/package.cgi?name=".SERVER::eurl($prg->menu)." scrolling=no>
                    <frame name=control src=control.cgi scrolling=no marginwidth=1>
               </frameset>    
            </frameset>\n");
}

# manages the control buttons (lower right screen)
sub control {
   my $self=shift;
   my $action=$self->field("action");
   $MAIN::config=$self->field("config") if((defined $self->field("config")) and ($self->field("config") ne ""));
   if (not defined $action) { $action = ''; };
   if($action eq "Quit Without Saving" || $action eq "Quit Configuration") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Good Bye</title></head>\n");
      $self->print_html("<body bgcolor=ffffff><p>&nbsp;<p>&nbsp;<center><h1 align=center>Good Bye from the Midori Linux Configurator!</h1>
                  <p align=center><img src=midori.gif></center></body></html>");
      my $s=$self->csocket;
      <$s>;
      exit(0);
   } elsif($action eq "Quit") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Quitting ?</title></head>\n");
      if($MAIN::edited) {
         $self->print_html("$body<h1>You really want to quit without saving your changes?</h1>");
      } else {
         $self->print_html("$body<h1>You really want to quit?</h1>");
      }
      $self->print_html("<p><form target=config action=control.cgi><input type=submit name=action value=\"Quit Configuration\">&nbsp;<input type=submit name=action value=\"Return to Configuration\"></form>\n");
      $self->print_html("<h2>Current values of the configuration file</h2>\n");
      my $top=MENU::get("");
      $top->print_changes($self->csocket);
   } elsif($action eq "Save to Configfile") {
      my $e=open(CONFIG,">".$self->field("config"));
      if(!$e) {
         $self->print_title;
         $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Error opening config file</title></head>\n");
         $self->print_html("<body bgcolor=aaaaff><h1>Error opening config \"".$self->field("config")."\" file: $!</h1>\n");
         $self->print_html("<p><a name=bottom></a><form target=main action=control.cgi>&nbsp;<a href=confighelp.html target=help>Configuration&nbsp;file</a>:&nbsp;<input type=text name=config value=\"".$MAIN::config."\">&nbsp;<input type=submit name=action value=\"Save to Configfile\">&nbsp;<input type=submit name=action value=\"Make More Changes\">&nbsp;<input type=submit name=action value=\"Quit Configuration\"></form>\n");
      } else {
         my $top=MENU::get("");
         $top->save(\*CONFIG);
         close(CONFIG);
         MAIN::reload();
         $self->print_title;
         $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Configuration Saved! </title></head>\n");
         $self->print_html("<body bgcolor=aaaaff><h1>Configuration saved to ".$MAIN::config."</h1>");
         $self->print_html("<form target=config action=control.cgi>Please chose: <input type=submit name=action value=\"Quit Configuration\">&nbsp;");
         $self->print_html("<input type=submit name=action value=\"Continuing with new Configfile\"></form>\n");
      }
   } elsif($action eq "Import") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Import Configfile</title></head>\n");
      $self->print_html("$body<h1>Please choose:</h1>");
      $self->print_html("<form target=main action=import.cgi><table border=0>");
      $self->print_html("<tr><th align=left><input type=submit name=what value=\"Continue\"></th><td>Don't import anything, continue normal editing</td></tr>");
      $self->print_html("<tr><th align=left><input type=submit name=what value=\"Enable\"></th><td>Enable all packages in the menu. You will most likely end up with a configuration file that will not work, as some packages cannot be installed simultaneously.</td></tr>");
      $self->print_html("<tr><th align=left><input type=submit name=what value=\"Disable\"></th><td>Disable all packages in order to select the ones you really want</td></tr>");
      $self->print_html("<tr><th align=left><input type=submit name=what value=\"Use Default Values\"></th><td>Reset all parameters to the default values</td></tr>");
      my $f=CONFIG::find_config_files("configurations");
      foreach my $i (sort (keys (%$f))) {
         (my $n=$i) =~ s/.*\/([^\/]*)\.config/$1/;
         $self->print_html("<tr><th align=left><input type=submit name=what value=\"$n\"></th><td>".$$f{$i}."</td></tr>");
      }
      $self->print_html("</table></form>\n");
   } elsif($action eq "Save") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Saving ?</title></head>\n");
      $self->print_html("$body<h1>The following parameters will be saved:</h1>");
      $self->print_html("In order to return without saving click on one of the package names in order to changes parameters for that package. The button to save is located at <a href=#bottom>the bottom</a> of this page<p>\n");
      $self->print_html("<table border=1>
            <tr><td bgcolor=ff0000>&nbsp;&nbsp;&nbsp;</td><td bgcolor=ffffff>This parameter has been set to
            an illegal value. You should probably not save it!</td></tr>
            <tr><td bgcolor=ffff00>&nbsp;&nbsp;&nbsp;</td><td bgcolor=ffffff>This parameter has the same value
            in your old and new config file, but this value is different than the default one.</td></tr>
            <tr><td bgcolor=ffaa00>&nbsp;&nbsp;&nbsp;</td><td bgcolor=ffffff>This parameter is different than
            in the original config file.</td></tr>
            <tr><td bgcolor=77ff77>&nbsp;&nbsp;&nbsp;</td><td bgcolor=ffffff>This parameter has been changed back
            to its default value.</td></tr>
            </table>");
      my $top=MENU::get("");
      $top->print_changes($self->csocket);
      $self->print_html("<p><a name=bottom></a><form target=config action=control.cgi>&nbsp;<a href=confighelp.html target=help>Configuration&nbsp;file</a>:&nbsp;<input type=text name=config value=\"".$MAIN::config."\">&nbsp;<input type=submit name=action value=\"Save to Configfile\">&nbsp;<input type=submit name=action value=\"Make More Changes\">&nbsp;<input type=submit name=action value=\"Quit\"></form>\n");
   } elsif($action eq "Reload") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Reload</title>$body<h1>Reload Configuration File</h1>\n");
      $self->print_html("If you do this you will lose all data that has not been saved to a configuration file yet. Please choose:\n");
      $self->print_html("<form target=config action=reload.cgi>&nbsp;<a href=confighelp.html target=help>Configuration&nbsp;file</a>:&nbsp;<input type=text name=config value=\"".$MAIN::config."\">&nbsp;<input type=submit name=action value=\"Abort Loading\">&nbsp;<input type=submit name=action value=\"Reload From File\"></form>\n");
      $self->print_html("<h2>Currently the following data would be saved to a configuration file:</h2>\n");
      my $top=MENU::get("");
      $top->print_changes($self->csocket);
   } elsif($action eq "Return to Configuration" || $action eq "Continuing with new Configfile" || $action eq "Make More Changes" || $action eq "Continue") {
      $self->send_file("/config.html");
   } else {
      $self->print_title;
      $self->print_html("<html><body bgcolor=aaaaff>
            <center><p align=center>
              <form target=main action=control.cgi>&nbsp;<a href=confighelp.html target=help>Configuration&nbsp;file</a>:&nbsp;<input type=text name=config value=\"".$MAIN::config."\">&nbsp;<input type=submit name=action value=Reload>&nbsp;<input type=submit name=action value=Save>&nbsp;<input type=submit name=action value=\"Import\">&nbsp;<input type=submit name=action value=Quit></form></TD>
            </body></html>");
   }
}

# Manages the import screen (after clicking on import),
# - show what if changes
# - import file
# Note: the selection screen that lists all import files is defined in the
# control function above.
sub import_config {
   my $self=shift;
   $what=$self->field("what");
   if($what eq "Continue") {
      $self->send_file("/welcome.html");
   } elsif($what eq "Continue Editing") {
      $self->send_file("/config.html");
   } elsif($what eq "Disable") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Disable all packages</title></head>$body<h1>Disable all packages</h1>\n");
      $self->print_html("The following currently enabled packages will be disabled (move to <a href=#bottom>the end of the page</a> to commit the change):<p>\n");
      MENU->top->print_disable($self->csocket);
      $self->print_html("<a name=bottom></a><form target=config action=import.cgi><input type=submit name=what value=\"Disable Those Packages\">&nbsp<input type=submit name=what value=\"Continue Editing\"></form></body></html>\n");
   } elsif($what eq "Disable Those Packages") {
      MENU->top->disable;
      $self->send_file("/config.html");
   } elsif($what eq "Enable") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Enable all packages</title></head>$body<h1>Enable all packages</h1>\n");
      $self->print_html("The following currently disabled packages will be enbled (move to <a href=#bottom>the end of the page</a> to commit the change):<p>\n");
      MENU->top->print_enable($self->csocket);
      $self->print_html("<a name=bottom></a><form target=config action=import.cgi><input type=submit name=what value=\"Enable Those Packages\">&nbsp<input type=submit name=what value=\"Continue Editing\"></form></body></html>\n");
   } elsif($what eq "Enable Those Packages") {
      MENU->top->enable;
      $self->send_file("/config.html");
   } elsif($what eq "Use Default Values") {
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Switch to Default Values</title></head>$body<h1>Switch to Default Values</h1>\n");
      $self->print_html("<p>Here the parameters that will be changed (go to <a href=#bottom>the bottom of the page</a> to commit the change):<p>\n");
      MENU->top->print_whatif_default($self->csocket);
      $self->print_html("<a name=bottom></a><form target=config action=import.cgi><input type=submit name=what value=\"Switch to Default Values\">&nbsp<input type=submit name=what value=\"Continue Editing\"></form></body></html>\n");
   } elsif($what eq "Switch to Default Values") {
      MENU->top->to_default;
      $self->send_file("/config.html");
   } elsif($what eq "Import File") {
      MENU->top->import_file(CONFIG::read_file($self->field("file")));
      $self->send_file("/config.html");
   } else {
      my $f="configurations/$what.config";
      my $c=CONFIG::read_file($f);
      $self->print_title;
      $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Import $what</title></head>$body<h1>Import $what</h1>\n");
      $self->print_html("<p>Here the parameters that will be changed (go to <a href=#bottom>the bottom of the page</a> to commit the change):<p>\n");
      MENU->top->print_whatif($self->csocket,$c);
      $self->print_html("<a name=bottom></a><form target=config action=import.cgi><input type=hidden name=file value=\"$f\"><input type=submit name=what value=\"Import File\">&nbsp<input type=submit name=what value=\"Continue Editing\"></form></body></html>\n");
   }
}

# Manages the 'Reload' button that appears after the config file got saved
sub reload {
   my $self=shift;
   $MAIN::config=$self->field("config") if($self->field("config") ne "");

   if($self->field("action") eq "Reload From File") {
      $MAIN::config=$self->field("config");
      MAIN::reload;
   }

   $c=$htmlrequest{"/config.html"};
   $self->print_title;
   $self->print_html($c);
   return 1;
}

# Display the help in their own, scrollable frame
sub help {
   my $self=shift;
   my $h=$self->field("help");
   $self->print_title;
   $self->print_html("<html><head><link rel=\"SHORTCUT ICON\" href=\"midori.ico\"><title>Midori Linux Configuration Utility</title></head><frameset border=0 rows=*,0 noresize frameborder=0 framespacing=0>".
                    "<frame src=$h scrolling=yes marginwidth=1><frame scrolling=yes marginwidth=1></frameset>\n");
   return 1;
}

# Handle a request
# - decode and read the fields
# - select the appropriate function to call
sub handle {
   my $self=shift;
   $self->csocket(@_);
   my $socket=$self->csocket;

   $req=<SOCKET>;
   ($cmd,$url,$protocol)=$req =~ /^(\S*)\s+(\S*)\s*(\S*)/;
   print "$ip: $cmd '$url' $protocol\n";

   $self->clear_fields;
   $self->url("");
   foreach $i (split(/[\?\&]/,$url)) {
      if($i =~ /^([^=]+)=(.*)/) {
         $name=$1;
         $value=$2;
         $name=~tr/+/ /;
         $name=~s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;   
         $value=~tr/+/ /;
         $value=~s/%([A-Fa-f0-9]{2})/pack("c",hex($1))/ge;   
         $self->field($name,$value);
      } else {
         $self->url($i) if($self->url eq "");
      }
   }
   $self->url("/index.html") if($self->url eq "/");
   $c=$htmlrequest{$self->url};
   if((defined $c) and ($c ne "")) {
      $self->print_title;
      $self->print_html($c);
      return 1;
   } elsif($self->url =~ /^\/[a-zA-Z0-9._-]+$/ && -f $ENV{HTDOCS}.$self->url) {
      $self->send_file($self->url);
   } elsif($self->url =~ /^\/(manual|packages)\/[a-zA-Z0-9._-]+$/ && -f $ENV{TOPDIR}."/docs".$self->url) {
      $self->send_file($self->url);
   } elsif($self->url eq "/menu.cgi") {
      $self->menu();
   } elsif($self->url eq "/packhelp.cgi") {
      $self->packhelp();
   } elsif($self->url eq "/packparm.cgi") {
      $self->packparm();
   } elsif($self->url eq "/package.cgi") {
      $self->package();
   } elsif($self->url eq "/config.cgi") {
      $self->config();
   } elsif($self->url eq "/configedit.cgi") {
      $self->configedit();
   } elsif($self->url eq "/reload.cgi") {
      $self->reload();
   } elsif($self->url eq "/import.cgi") {
      $self->import_config();
   } elsif($self->url eq "/help.cgi") {
      $self->help();
   } elsif($self->url eq "/control.cgi") {
      $self->control();
   } else {
      $self->http_error(404,"Document not found");
   }
}

# Main server: very simple, non threaded or multitask: every request
# is handled to completion before the next is done.
sub server {
   my $self={ };
   bless $self;
   my $prg=PRG::get("build/configurator");
   my $ml=$prg->child($prg->edit);
   $proto = getprotobyname('tcp');
   socket(SERVER, PF_INET, SOCK_STREAM, getprotobyname('tcp')) || die "Error opening server socket: $!\n";
   setsockopt(SERVER, SOL_SOCKET, SO_REUSEADDR, pack("l", 1)) || die "Error setting socket options: $!\n";
   bind(SERVER, sockaddr_in($ml->param('CONFIGURATOR_PORT')->edit, INADDR_ANY)) || die "Error binding port: $!\n";
   listen(SERVER, SOMAXCONN) || die "Error listening: $!\n";

   print "Now listening on port ".$ml->param('CONFIGURATOR_PORT')->edit.", use  http://127.0.0.1:".$ml->param('CONFIGURATOR_PORT')->edit."/\n";
   while(1) {
      $allowed=$ml->param('CONFIGURATOR_CLIENT')->edit;
      $conn=accept(SOCKET, SERVER);
      if ($conn) {
         $ip =inet_ntoa((unpack_sockaddr_in($conn))[1]);
         if($ip =~ $allowed) {
            select(SOCKET); $|=1;
            select(STDOUT); $|=1;
            $self->handle(\*SOCKET);
         } else {
            print STDERR "illegal connection request from $ip, ignoring it.\n";
         }
         <SOCKET>; # if socket is closed too early netscape screams
         close(SOCKET);
      } else {
         print "accept failed?\n";
      }
   }
}

1;
